---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
Please provide us with the following to receive timely help:
1. A minimum example to reproduce the bug, including configuration files, code files, model definition, and the command to run. It's better to share everything using a file-sharing service (e.g., Google drive).
2. Model files, especially when the bug is only triggered on specific models.
3. **Complete** outputs of the program when the bug is triggered. Please do **not** just include the last few lines. If it's very long, you can use [PasteBin](https://pastebin.com/) or upload to a file-sharing service.
4. Detailed instructions to reproduce the problem. If you changed part of the verifier, please rebase your changes to main branch and push your changes to a fork so we can investigate easier.

Without the above information, you might not be able to receive timely help from us.


**System configuration:**
 - OS: [e.g. Ubuntu 22.04. Windows and MacOS are not supported.]
 - Python version: [e.g., Python 3.8]
 - Pytorch Version: [e.g., PyTorch 1.12]
 - Hardware: [e.g., RTX 4090]
 - Have you tried to reproduce the problem in a cleanly created conda/virtualenv environment using official installation instructions and the latest code on the main branch?: [Yes/No]

**Screenshots**
If applicable, add screenshots to help explain your problem.

**Additional context**
Add any other context about the problem here.
